<template>
  <mt-box class="mt-box-commentaire" :class="{ 'fil-discution': isFilDeDiscustion }">
    <article class="mt-commentaire columns is-vcentered is-mobile">
      <div class="column is-narrow">
        <mt-pastille is-blue>{{ redacteur.initial }}</mt-pastille>
      </div>
      <div class="column">
        <p class="mt-nom-prenom">
          <mt-utilisateur :utilisateur="redacteur"></mt-utilisateur>
        </p>
        <p class="mt-message">{{ commentaire.commentaire }}</p>
      </div>
      <div class="column is-narrow">
        <template v-if="testPresenceCommentaireDateValidation()">
          <time class="solo">{{ date() }}</time>
          <span class="mt-statut" :class="{ 'mt-statut-red': commentaire.choix.actionSuppression }">{{
            commentaire.statut.nom
          }}</span>
        </template>
        <template v-if="testPresenceCommentaireDateDebut()">
          <time
            ><mt-disponibilite-puce :type-disponibilite="commentaire.typeDisponibilite"></mt-disponibilite-puce
            >{{ dateDispo(commentaire.dateDebut) }} - {{ dateDispo(commentaire.dateFin) }}</time
          >
        </template>
      </div>
    </article>
  </mt-box>
</template>

<script>
import { DateTime } from 'luxon';
import MtBox from '~/components/base/box';
import MtPastille from '~/components/base/pastille/index';
import MtUtilisateur from '~/components/pax/mt-utilisateur';
import MtDisponibilitePuce from '~/components/disponibilite/disponibilite-puce';

export default {
  name: 'MtCommentaire',
  components: { MtDisponibilitePuce, MtUtilisateur, MtPastille, MtBox },
  props: {
    commentaire: {
      type: Object,
      default: () => ({}),
    },
    redacteur: {
      type: Object,
      default: () => ({}),
    },
    isFilDeDiscustion: Boolean,
  },
  methods: {
    date() {
      const date = DateTime.fromISO(this.commentaire.dateValidation);
      return this.dateDispo(date);
    },
    dateDispo(dateNonFormat) {
      if (dateNonFormat) {
        return dateNonFormat.toFormat('dd/MM/yyyy');
      }
      return '';
    },
    testPresenceCommentaireDateValidation() {
      return this.commentaire.dateValidation;
    },
    testPresenceCommentaireDateDebut() {
      return this.commentaire.dateDebut;
    },
  },
};
</script>

<style scoped lang="scss">
@import '~/assets/css/_variables';
.mt-box {
  margin: 0.5rem;
}

.mt-commentaire {
  padding: 0.25rem;
  flex-direction: row;

  div {
    display: flex;
    flex-direction: column;
  }
}
/deep/ .mt-pastille {
  margin: 0.3rem;
}
.mt-nom-prenom {
  grid-area: personne;
  font-size: 0.75rem;
  color: $primary;
  font-weight: bold;
  text-align: left;
}
.mt-message {
  grid-area: message;
  font-size: 0.875rem;
  color: #5f5f5f;
  text-align: left;
}
time {
  text-align: right;
  font-size: 0.75rem;
  color: #bfbfbf;
  padding: 0.2em;
}
.mt-statut {
  font-weight: bold;

  &.mt-statut-red {
    background-color: #fdeef3;
    color: #d23268;
  }
}
.mt-box-commentaire.fil-discution + .mt-box-commentaire.fil-discution {
  margin-top: 1rem;
}
.mt-box-commentaire.fil-discution + .mt-box-commentaire.fil-discution:before {
  content: '';
  position: absolute;
  height: 1.5rem;
  top: -1.5rem;
  left: 2rem;
  width: 1px;
  background-color: #dfdfdf;
  z-index: 0;
}
.indispo {
  color: $puce-indisponible;
}
.dispo {
  color: $puce-disponible;
}
</style>
